#ifndef HAL_ISRDISPATCH_H
#define HAL_ISRDISPATCH_H

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include "pkgconf/system.h"

#if !defined(CYG_HAL_STARTUP_STUBS) && defined(CYG_HAL_MPC555)
#include "cyg/infra/cyg_type.h"

//------------------
// Class declaration
//------------------
class HAL_isrDispatcher
{
  public:
                         HAL_isrDispatcher();
    virtual              ~HAL_isrDispatcher();

    bool                 attach(unsigned char a_level);
    void                 detach(void);
    void                 enableIsrDispatching(void);
    void                 disableIsrDispatching(void);
    void                 enableInterrupts(void);
    void                 disableInterrupts(void);

  protected:
    virtual cyg_uint32   findInterruptingVector(void) = 0;
    virtual bool         setInterruptingLevel(unsigned char a_level) = 0;
    virtual void         enableInterruptingDevice(void) = 0;
    virtual void         disableInterruptingDevice(void) = 0;

    cyg_uint32           m_vector;
  private:
    typedef cyg_uint32 (* isr)(CYG_ADDRWORD a_vector, CYG_ADDRWORD a_data);

    static cyg_uint32    sDispatch(CYG_ADDRWORD a_vector, HAL_isrDispatcher * a_dispatcher);
    cyg_uint32           dispatch(CYG_ADDRWORD a_vector);
    cyg_uint32           callISR(CYG_ADDRWORD a_vector);
};
#endif // if !defined....

#endif // HAL_ISRDISPATCH
