#ifndef KCLOCKTICKGENERATOR_H
#define KCLOCKTICKGENERATOR_H

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include <cyg/kernel/kapi.h>

//-----------------
// Type definitions
//-----------------
typedef cyg_handle_t     KClockHandle;
typedef cyg_resolution_t KClockResolution;

//------------------
// Class declaration
//------------------
class KClockTickGenerator
{
  public:
                                   KClockTickGenerator();
    virtual                        ~KClockTickGenerator();

    KClockHandle                   asClock(void)
                                   {
                                     return m_asclock;
                                   }
    KClockHandle                   asCounter(void)
                                   {
                                     return m_ascounter;
                                   }
    unsigned long                  timeToTicks(unsigned long a_microsecs);
    unsigned long                  currentTime(void);

  protected:
    KClockHandle                   m_asclock;
    KClockHandle                   m_ascounter;
    float                          m_factor;

  public:
    static KClockTickGenerator *   m_highres;
    static KClockTickGenerator *   m_normalres;
    static KClockTickGenerator *   m_lowres;
};

class KHighResolutionClockTickGenerator : public KClockTickGenerator,
                                          public cyg_clock
{
  public:
                                   KHighResolutionClockTickGenerator(KClockResolution a_resolution);
    virtual                        ~KHighResolutionClockTickGenerator();

    void                           generateTicks(unsigned long a_ticks);
};

#endif // KCLOCKTICKGENERATOR_H
