#ifndef KTIMERBASE_H
#define KTIMERBASE_H

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include "cyg/kal/ktimer.h"
#include "cyg/kal/kthread.h"
#include "cyg/kal/ksync.h"
#include "kclocktickgenerator.h"

//-------------------
// Class declarations
//-------------------
// Class KTimerBase
class KTimerBase : public KThread
{
  public:
                            KTimerBase(unsigned int a_priority, char * a_name,
                                       void * a_stack, size_t a_stack_size,
                                       KClockTickGenerator * a_clock);
    virtual                 ~KTimerBase();

    void                    add(KTimer * a_timer)
                            {
                              m_timers.add(a_timer);
                              m_cond.signal();
                            }
    void                    remove(KTimer * a_timer)
                            {
                              m_timers.remove(a_timer);
                            }
    unsigned long           getInterval(unsigned long a_microsecs)
                            {
                              return m_clock->timeToTicks(a_microsecs);
                            }
    unsigned long           getTimeOut(unsigned long a_microsecs)
                            {
                              return (m_clock->timeToTicks(a_microsecs) + m_clock->currentTime());
                            }
    KClockHandle            getClock(void)
                            {
                              return m_clock->asCounter();
                            }

  private:
    void                    threadEntry(void);

    KCondition              m_cond;
    KTimerList              m_timers;
    KClockTickGenerator *   m_clock;
};

#endif // KTIMERBASE_H
